%% TEST 2 - TOTAL ROAD RACE COURSE MEASUREMENT 
%% LOAD OF DATA 
% The load of data collects files from different dates in order to join
% them and analyse then as a complete set

clear all
close all
clc

mydir  = pwd;
idcs   = strfind(mydir,'\');
fold = [pwd '\UTILES']   
cd (fold) 

%The 'NEW_TRACK' files represent the set of tracks of GPS 1, 2 and 3. They were made using the file data_binding.m


% SET 4 RIDES 23/08/2021
load('NEW_TRACKS1');  % 5 rides
n=1;
numfiles=size(CUT,1);
for i=1:numfiles
    GPS{n}= CUT{i,1};
    CELL{n} =CUT{i,2};
    SW{n} = CUT{i,3};
    n=n+1;
end

% SET 3 RIDES 21/11/2021
load('NEW_TRACKS2');  % 4 rides
% The first track is a continuous measurement, thus must be deleted
numfiles=size(CUT,1);
for i=1:numfiles
    GPS{n}= CUT{i,1};
    CELL{n} =CUT{i,2};
    SW{n} = CUT{i,3};
    n=n+1;
end

% SET 4 RIDES 19/02/2022
load('NEW_TRACKS3');  % 4 rides
% The first track is a continuous measurement, thus must be deleted
numfiles=size(CUT,1);
for i=1:numfiles
    GPS{n}= CUT{i,1};
    CELL{n} =CUT{i,2};
    SW{n} = CUT{i,3};
    n=n+1;
end

%% PLOT
figure(1)
for i=1:length(GPS)
    
    subplot(2,2,1)
    geoplot(GPS{1,i}.Latitude,GPS{1,i}.Longitude); hold on;
    %legend(['Trial' num2str(i)] ); hold on;
    legend({'Trial 1','Trial 2','Trial 3','Trial 4','Trial 5','Trial 6','Trial 7','Trial 8','Trial 9','Trial 10'});
    title('GPS Traking')
    
    subplot(2,2,2)
    geoplot(CELL{1,i}.Latitude,CELL{1,i}.Longitude);hold on;
    %legend(['Trial' num2str(i)] ); hold on;
    legend({'Trial 1','Trial 2','Trial 3','Trial 4','Trial 5','Trial 6','Trial 7','Trial 8','Trial 9','Trial 10'});
    title('CELL Traking')
    
    subplot(2,2,3)
    geoplot(SW{1,i}.Latitude,SW{1,i}.Longitude);hold on;
    %legend(['Trial' num2str(i)] ); hold on;
    legend({'Trial 1','Trial 2','Trial 3','Trial 4','Trial 5','Trial 6','Trial 7','Trial 8','Trial 9','Trial 10'});
    title('TomTom Traking')
    
    subplot(2,2,4)
    if i>2  % Loading the ARDUINO files 
        
    d=load(strcat('ARD',num2str(i-2),'.mat'));  d=d.ARD;
    dLat=d(:,2); dLon=d(:,3);
    
    DMLat=abs(floor(dLat/100))+abs((mod(dLat/100,1)*100))/60;       % Converzione da DDMM.MMMM to Decimal Degrees
    DMLon=abs(floor(dLon/100))+abs((mod(dLon/100,1)*100))/60;
    
    geoplot(DMLat,DMLon);hold on;
    %legend(['Trial' num2str(i)] ); hold on;
    legend({'Trial 1','Trial 2','Trial 3','Trial 4','Trial 5','Trial 6','Trial 7','Trial 8','Trial 9','Trial 10'});
    title('Arduino Traking')
    end
end
sgtitle("ROAD RACE COURSES")



%% LONGITUDE MEASUREMENT  
% LUNGHEZZA MASSIMA VETTORE DI DISTANZA 

 data = cellfun(@size,CELL,'uni',false);
 amax=0;
     % Midice quale sarà la lunghezza massima del mio vettore di distanza 
     for f=1:length(GPS)
         if max(data{1,f})>amax 
             amax=max(data{1,f});
         end
     end

matricea=[];matriceb=[];matricec=[];matriced=[];errors=[];
for k=1:length(GPS)
    
    a = GPS{1,k};
    b = CELL{1,k};
    c = SW{1,k};
    
    aLat=a.Latitude; bLat=b.Latitude; cLat=c.Latitude;
    aLon=a.Longitude; bLon=b.Longitude; cLon=c.Longitude;
    
    % geoshow(Lat,Lon,'DisplayType','line','Color','red');
    % grid on;

    ellipsoid = wgs84Ellipsoid('meter'); % Reference ellipsoid for World Geodetic System 1984

     % Prende tutti i punti dei track e calcolla la distanza utilizzando
     % una referenza
     
     %ATTENZIONE:  Devo inizializzare sempre ilv ettore distanza
     ad=zeros(1,amax);
     bd=zeros(1,amax); 
     cd=zeros(1,amax);
     dd=zeros(1,amax);
     
    for i=1:length(a)-1
        a_arclen(i) = distance(aLat(i),aLon(i),aLat(i+1),aLon(i+1)); 
        ad(i) = distance(aLat(i),aLon(i),aLat(i+1),aLon(i+1),ellipsoid);
%         [a_arclen(i),ad(i)] = distance(aLat(i),aLon(i),aLat(i+1),aLon(i+1),ellipsoid);
    end

     for i=1:length(b)-1
        b_arclen(i) = distance(bLat(i),bLon(i),bLat(i+1),bLon(i+1)); 
        bd(i) = distance(bLat(i),bLon(i),bLat(i+1),bLon(i+1),ellipsoid);
%       [b_arclen(i),bd(i) ]= distance(bLat(i),bLon(i),bLat(i+1),bLon(i+1),ellipsoid);
     end
     
     for i=1:length(c)-1
        c_arclen(i) = distance(cLat(i),cLon(i),cLat(i+1),cLon(i+1)); 
        cd(i) = distance(cLat(i),cLon(i),cLat(i+1),cLon(i+1),ellipsoid);
%       [b_arclen(i),bd(i) ]= distance(bLat(i),bLon(i),bLat(i+1),bLon(i+1),ellipsoid);
     end
     if k>2
         
    d=load(strcat('ARD',num2str(k-2),'.mat'));  d=d.ARD;
    dLat=d(:,2); dLon=d(:,3);
    
    DMLat=abs(floor(dLat/100))+abs((mod(dLat/100,1)*100))/60;       % Converzione da DDMM.MMMM to Decimal Degrees
    DMLon=abs(floor(dLon/100))+abs((mod(dLon/100,1)*100))/60;
    
      for i=1:length(d)-1
        d_arclen(i) = distance(DMLat(i),DMLon(i),DMLat(i+1),DMLon(i+1)); 
        dd(i) = distance(DMLat(i),DMLon(i),DMLat(i+1),DMLon(i+1),ellipsoid);
%       [b_arclen(i),bd(i) ]= distance(bLat(i),bLon(i),bLat(i+1),bLon(i+1),ellipsoid);
      end
     end
     
     % Distance between first and last point tracked
      errors(k,:)=[distance(aLat(end),aLon(end),aLat(1),aLon(1),ellipsoid)
                   distance(bLat(end),bLon(end),bLat(1),bLon(1),ellipsoid) 
                   distance(cLat(end),cLon(end),cLat(1),cLon(1),ellipsoid)
                   distance(DMLat(end),DMLon(end),DMLat(1),DMLon(1),ellipsoid)];
    % All distances 
      matricea(:,k)=ad';
      matriceb(:,k)=bd'; 
      matricec(:,k)=cd';
      matricec(:,k)=dd';
    
Distanza(k,1) = sum(ad);  %This variable contain all the distance values 
Distanza(k,2) = sum(bd);
Distanza(k,3) = sum(cd);
Distanza(k,4) = sum(dd);
end 
%%
%save('DISTANCE_MEASUREMENTS.mat','Distanza')
% The problems of the variable distance are the missing registered race
% courses (ARDUINO) and the outliers values of TomTom. The variable is then
% modified and saved as DITANCE MEASUREMENTS,that must be loaded subsequently 


% Necessary to load the data without outliers-> DISTANCE MEASUREMENTS.mat
load('DISTANCE_MEASUREMENTS.mat')
%Distanza=Distanza3;
TV=2215.894; %[m]
SE=2.532;   %[m]

figure(2)
boxplot([Distanza(:,1), Distanza(:,2), Distanza(:,3), Distanza(:,4)],'Notch','on','Labels',{'GPS 1','GPS 2','GPS 3','GPS 4'})
title('Boxplot of GPD distances')
line(1:4,[TV,TV,TV,TV], 'LineWidth',0.5)
line(1:4,[TV+SE,TV+SE,TV+SE,TV+SE], 'LineWidth',0.2)
line(1:4,[TV-SE,TV-SE,TV-SE,TV-SE], 'LineWidth',0.2)
%% DISTANCE STATISTICS 

media = [mean(Distanza(:,1)); mean(Distanza(:,2));mean(Distanza(:,3));mean(Distanza(:,4))];
standard_dev = [std(Distanza(:,1)) ; std(Distanza(:,2)); std(Distanza(:,3));std(Distanza(:,4))]; % Deviazione standard 

figure()
errorbar( media ,standard_dev,'o','MarkerSize',10,'MarkerFaceColor','red','LineWidth',2);
title('Error plot of GPS distances')
ylabel('Measured Distance [meters]')
box on
gpsnames = {'GPS 1','GPS 2','GPS 3','GPS 4',''};
set(gca, 'XTick', 1:4, 'XTickLabel', gpsnames)
line(1:4,[TV,TV,TV,TV], 'LineWidth',0.5)
line(1:4,[TV+SE,TV+SE,TV+SE,TV+SE], 'LineWidth',0.2)
line(1:4,[TV-SE,TV-SE,TV-SE,TV-SE], 'LineWidth',0.2)
axis([0 5 2205 2235])

%SD_Relativa  = [standard_dev(1)/media(1) ; standard_dev(2)/media(2);  standard_dev(3)/media(3)]*100; % è lo stesso che deviazione standar relativa 
skew =[skewness(Distanza(:,1)); skewness(Distanza(:,2)); skewness(Distanza(:,3)); skewness(Distanza(:,4))]; % ver la cosa del bias o unbias
kurt =[kurtosis(Distanza(:,1)); kurtosis(Distanza(:,2));  kurtosis(Distanza(:,3));kurtosis(Distanza(:,4))]; % ver la cosa del bias o unbias
tab= table({'DATI GPS 1';'DATI GPS 2';'DATI GPS 3';'DATI GPS 4'}, media ,standard_dev , skew, kurt)
