#include <Adafruit_GPS.h> // Install the asafruit GPS library
#include <SoftwareSerial.h>  // Load the software Serial library 
#include <SD.h>  // Load the SD library
#include <SPI.h>  // Load the SPI library 

SoftwareSerial mySerial(3,2);  // Initialize the software Serial port
Adafruit_GPS GPS(&mySerial);   // object name = GPS and i'm going to connect it to mySerial
                               // Create the GPS object

String NMEA1;  // Variable for first NMEA sentence
String NMEA2;  // Variable for second NMEA sentence
char c; // to read characters coming from the GPS
int chipSelect = 10;  // Chip select is connected to arduino pin 10 
File mySensorData;    // Declare variable for your SD card object 
String wFile = "DATA"; 

void setup() {
  // put your setup code here, to run once:
    // SETUP GPS MODULE
    Serial.begin(115200); // Turn on serial monitor 
    GPS.begin(9600);     // Turn on GPS at 9600 baud
    GPS.sendCommand("$PGCMD,33,0*6D");  // Turn off antenna update nuisance data
    GPS.sendCommand(PMTK_SET_NMEA_UPDATE_1HZ); // Set update rate to 1 Hz
    GPS.sendCommand(PMTK_SET_NMEA_OUTPUT_RMCGGA); // Request RMC and GGA sentences only 
    //delay(1000);

    // SETUP SD CARD MODULE
    pinMode(4, OUTPUT);   // Declare pin 4 to power the led 
    pinMode(7,OUTPUT);   // Must declare pin 8 an output to keep SD card reader happy
    SD.begin(chipSelect);  // Initialize our SD card an say it is connected to chipSelect

    if(SD.begin(chipSelect)){
      Serial.print("sd card inicializada bien ");
    }

    bool file = false;  //tracks when we found a file name we can use
    int count = 0;    //used for naming the file
    while(!file){
      if (SD.exists(wFile + ".txt")){ // Check to see if NMEA.txt is on SD card, if so, delete it
          count++; //up the count for naming the file
          wFile = "DATA" + (String)count; //make a new name
          Serial.print("Necesario hacer nuevo documento ");
      }else file =true;   
    }
//     if (SD.exists("GPSData.txt")){ // Check to see if NMEA.txt is on SD card, if so, delete it
//      SD.remove("GPSData.txt");
//    }
    
}

void loop() {
  // put your main code here, to run repeatedly:
    readGPS();
    Serial.print("GPS listo?: ");
    Serial.print(GPS.fix);
    if(GPS.fix ==1){    // Only log data after you have a fix
      digitalWrite(4, HIGH); ;// turn on the LED when GPS is fixed
      mySensorData =SD.open((wFile + ".txt"),FILE_WRITE);   // Open NMEA.csv for writing 
//     //Serial.print(" Esta grabando los datos ");
      mySensorData.print(NMEA1);    // Write first sentence to the SD card
      //mySensorData.print(NMEA2);    // Write first sentence to the SD card
//      mySensorData.close();   //Close the file
//        mySensorData = SD.open("GPSData.txt",FILE_WRITE); // Open the GPSData.txt file on SD card
//        mySensorData.print(GPS.hour, DEC);  mySensorData.print(':');
//        mySensorData.print(GPS.minute, DEC);  mySensorData.print(':');
//        mySensorData.print(GPS.seconds, DEC);mySensorData.print(",");
//        mySensorData.print(GPS.latitude,4); // Write latitude to the GPS file 
//        mySensorData.print(GPS.lat); // Which hemisphere you are in N or S 
//        mySensorData.print(",");  //write a comma
//        mySensorData.print(GPS.longitude,4);   // write longitude to the GPS file
//        mySensorData.print(GPS.lon); // which hemisphere you are in E or W
//        mySensorData.println(",");  //write a comma
        mySensorData.close();   //close your file
    }
    
    if(GPS.fix ==0){
      digitalWrite(13, LOW); ;// turn on the LED when GPS is fixed
    }
    
}

void readGPS(){
    // I want to set and loop until i get a new nmea sentence
    clearGPS();  // Because of the corrupt data starting
    
    while(!GPS.newNMEAreceived()){  // Loop until you have a good NMEA sentence
    c=GPS.read();
    }
    GPS.parse(GPS.lastNMEA());  //Parse that last good NMEA sentence
    NMEA1 = GPS.lastNMEA();

//    while(!GPS.newNMEAreceived()){  // Loop until you have a good NMEA sentence
//    c=GPS.read();
//    }
//    GPS.parse(GPS.lastNMEA());  //Parse that last good NMEA sentence
//    NMEA2 = GPS.lastNMEA();

   Serial.print(NMEA1);
    //Serial.print(NMEA2);
   
}

void clearGPS(){   // Clear old and corrupt data from serial port
    while(!GPS.newNMEAreceived()){  // Loop until you have a good NMEA sentence
    c=GPS.read();
    //c=GPS.read();
    }
    GPS.parse(GPS.lastNMEA());  //Parse that last good NMEA sentence

//     while(!GPS.newNMEAreceived()){  // Loop until you have a good NMEA sentence
//    c=GPS.read();
//    }
//    GPS.parse(GPS.lastNMEA());  //Parse that last good NMEA sentence
//  
}
